## libkf5libkleo 23.08.0

=== debian/changelog ===
libkf5libkleo (4:23.08.0-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.08.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 24 Aug 2023 13:01:01 +0100

libkf5libkleo (4:23.07.90-0ubuntu1) mantic; urgency=medium

  * New upstream (beta) release (23.07.80)
  * New upstream (RC) release (23.07.90)

 -- Rik Mills <rikmills@kde.org>  Tue, 15 Aug 2023 02:40:27 +0100

libkf5libkleo (4:23.04.3-0ubuntu3) mantic; urgency=medium

  * More fixes for data package breaks/replaces.

 -- Rik Mills <rikmills@kde.org>  Tue, 18 Jul 2023 21:13:34 +0100

libkf5libkleo (4:23.04.3-0ubuntu2) mantic; urgency=medium

  * d/control: Fix data package 'Replaces:' version. 21.04.1 -> 23.04.1

 -- Rik Mills <rikmills@kde.org>  Tue, 18 Jul 2023 18:10:14 +0100

libkf5libkleo (4:23.04.3-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Jul 2023 14:56:39 +0100

libkf5libkleo (4:23.04.2-0ubuntu2) mantic; urgency=medium

  [ José Manuel Santamaría Lema ]
  * Add libkf5textaddons-dev to Build-Depends.

 -- Rik Mills <rikmills@kde.org>  Mon, 12 Jun 2023 13:36:43 +0100

libkf5libkleo (4:23.04.2-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.04.1)
  * Refreshed patch enable_debianabimanager.diff
  * Rename library libkf5libkleo5abi1 -> libkpim5libkleo5
  * Remove symbols files, no longer used
  * Rename data package: libkf5libkleo-data -> libkpim5libkleo-data
  * Add Multi-Arch to -data package, fix depends
  * New upstream release (23.04.2)
  * Add libkf5textaddons-dev to Build-Depends

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Mon, 12 Jun 2023 13:01:03 +0100

libkf5libkleo (4:22.12.3-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 02 Mar 2023 00:45:17 +0000

libkf5libkleo (4:22.12.2-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.2)

 -- Simon Quigley <tsimonq2@kubuntu.org>  Sat, 11 Feb 2023 14:28:28 -0600

libkf5libkleo (4:22.12.1-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.1)

 -- Rik Mills <rikmills@kde.org>  Mon, 09 Jan 2023 17:27:30 +0000

libkf5libkleo (4:22.12.0-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.0)

 -- Rik Mills <rikmills@kde.org>  Fri, 09 Dec 2022 19:17:06 +0000

libkf5libkleo (4:22.11.90-0ubuntu1) lunar; urgency=medium

  * New upstream (RC) release (22.11.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 25 Nov 2022 16:13:17 +0000

libkf5libkleo (4:22.11.80-0ubuntu1) lunar; urgency=medium

  * New upstream (beta) release (22.11.80)
  * Update symbols.

 -- Rik Mills <rikmills@kde.org>  Thu, 17 Nov 2022 10:40:54 +0000

libkf5libkleo (4:22.08.3-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.08.2)
  * New upstream release (22.08.3)

 -- Rik Mills <rikmills@kde.org>  Mon, 07 Nov 2022 11:16:05 +0000
