=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
                libkf5coreaddons-dev (>= 5.31.0~),
                libkf5i18n-dev (>= 5.31.0~),
                libkf5itemmodels-dev (>= 5.31.0~),
-               libkf5pimtextedit-dev (>= 23.08.1~),
+               libkf5pimtextedit-dev (>= 23.08.4~),
                libkf5textaddons-dev,
                libkf5widgetsaddons-dev (>= 5.31.0~),
                libkf5windowsystem-dev (>= 5.31.0~),
